[![Backers on Open Collective](https://opencollective.com/redom/backers/badge.svg)](#backers) [![Sponsors on Open Collective](https://opencollective.com/redom/sponsors/badge.svg)](#sponsors) [![js-semistandard-style](https://img.shields.io/badge/code%20style-semistandard-brightgreen.svg?maxAge=60&style=flat-square)](https://github.com/Flet/semistandard)
[![Build Status](https://img.shields.io/travis/redom/redom/master.svg?maxAge=60&style=flat-square)](https://travis-ci.org/redom/redom?branch=master)
[![npm](https://img.shields.io/npm/v/redom.svg?maxAge=60&style=flat-square)](https://www.npmjs.com/package/redom)
[![npm](https://img.shields.io/npm/l/redom.svg?maxAge=60&style=flat-square)](https://github.com/redom/redom/blob/master/LICENSE)
[![Join the chat at https://gitter.im/pakastin/redom](https://badges.gitter.im/pakastin/redom.svg)](https://gitter.im/pakastin/redom?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
[![Twitter Follow](https://img.shields.io/twitter/follow/pakastin.svg?style=social&maxAge=60)](https://twitter.com/pakastin)
[![Twitter Follow](https://img.shields.io/twitter/follow/redomjs.svg?style=social&maxAge=60)](https://twitter.com/redomjs)

[![RE:DOM](https://redom.js.org/img/title.png?5)](https://redom.js.org)

# RE:DOM

Develop web apps with 100 % JavaScript and web standards. 🚀

https://redom.js.org

## Introduction

RE:DOM is a tiny (2 KB) UI library by [Juha Lindstedt](https://github.com/pakastin) and [contributors](https://github.com/redom/redom/graphs/contributors), which adds some useful helpers to create DOM elements and keeping them in sync with the data.

Because RE:DOM is so close to the metal and **doesn't use virtual dom**, it's actually **faster** and uses **less memory** than almost all virtual dom based libraries, including React ([benchmark](https://rawgit.com/krausest/js-framework-benchmark/master/webdriver-ts-results/table.html)).

It's also easy to create **reusable components** with RE:DOM.

Another great benefit is, that you can use just **pure JavaScript**, so no complicated templating languages to learn and hassle with.

## Installing
```
npm i redom
```

## Get started
- [Documentation](https://redom.js.org/documentation)
- ["Minimum viable view library"](https://www.youtube.com/watch?v=0nh2EK1xveg) - talk @ HelsinkiJS - see what's happening under the hood

## Tools
- [NO:DOM](https://github.com/redom/nodom) (server-side rendering)
- [Project generator](https://github.com/redom/redom-cli)
- [Dev tools for Chrome](https://github.com/redom/redom-devtools)
- [Babel RE:DOM JSX transform](https://github.com/tomerigal/babel-plugin-transform-redom-jsx)

## Performance
- [RE:DOM is one of the fastest UI library out there.](https://rawgit.com/krausest/js-framework-benchmark/master/webdriver-ts-results/table.html)

## Open source
- License: [MIT](https://github.com/redom/redom/blob/master/LICENSE)

## Contributors

This project exists thanks to all the people who contribute. [[Contribute](CONTRIBUTING.md)].
<a href="https://github.com/redom/redom/graphs/contributors"><img src="https://opencollective.com/redom/contributors.svg?width=890&button=false" /></a>


## Backers

Thank you to all our backers! 🙏 [[Become a backer](https://opencollective.com/redom#backer)]

<a href="https://opencollective.com/redom#backers" target="_blank"><img src="https://opencollective.com/redom/backers.svg?width=890"></a>


## Sponsors

Support this project by becoming a sponsor. Your logo will show up here with a link to your website. [[Become a sponsor](https://opencollective.com/redom#sponsor)]

<a href="https://opencollective.com/redom/sponsor/0/website" target="_blank"><img src="https://opencollective.com/redom/sponsor/0/avatar.svg"></a>
<a href="https://opencollective.com/redom/sponsor/1/website" target="_blank"><img src="https://opencollective.com/redom/sponsor/1/avatar.svg"></a>
<a href="https://opencollective.com/redom/sponsor/2/website" target="_blank"><img src="https://opencollective.com/redom/sponsor/2/avatar.svg"></a>
<a href="https://opencollective.com/redom/sponsor/3/website" target="_blank"><img src="https://opencollective.com/redom/sponsor/3/avatar.svg"></a>
<a href="https://opencollective.com/redom/sponsor/4/website" target="_blank"><img src="https://opencollective.com/redom/sponsor/4/avatar.svg"></a>
<a href="https://opencollective.com/redom/sponsor/5/website" target="_blank"><img src="https://opencollective.com/redom/sponsor/5/avatar.svg"></a>
<a href="https://opencollective.com/redom/sponsor/6/website" target="_blank"><img src="https://opencollective.com/redom/sponsor/6/avatar.svg"></a>
<a href="https://opencollective.com/redom/sponsor/7/website" target="_blank"><img src="https://opencollective.com/redom/sponsor/7/avatar.svg"></a>
<a href="https://opencollective.com/redom/sponsor/8/website" target="_blank"><img src="https://opencollective.com/redom/sponsor/8/avatar.svg"></a>
<a href="https://opencollective.com/redom/sponsor/9/website" target="_blank"><img src="https://opencollective.com/redom/sponsor/9/avatar.svg"></a>


